[pass] [PATCH] cygwin + gpg4win: convert paths to windows paths when calling gpg4win binary instead of cygwin's gpg binary
Lenz Weber
mail at lenzw.de
Wed Jan 28 16:32:53 CET 2015
---
src/password-store.sh | 2 +-
src/platform/cygwin.sh | 26 ++++++++++++++++++++++++++
2 files changed, 27 insertions(+), 1 deletion(-)
diff --git a/src/password-store.sh b/src/password-store.sh
index f98c6e9..ef862a3 100755
--- a/src/password-store.sh
+++ b/src/password-store.sh
@@ -310,7 +310,7 @@ cmd_show() {
check_sneaky_paths "$path"
if [[ -f $passfile ]]; then
if [[ $clip -eq 0 ]]; then
- exec $GPG -d "${GPG_OPTS[@]}" "$passfile"
+ $GPG -d "${GPG_OPTS[@]}" "$passfile" || exit $?
else
local pass="$($GPG -d "${GPG_OPTS[@]}" "$passfile" | head -n 1)"
[[ -n $pass ]] || exit 1
diff --git a/src/platform/cygwin.sh b/src/platform/cygwin.sh
index 05c51e0..c513494 100644
--- a/src/platform/cygwin.sh
+++ b/src/platform/cygwin.sh
@@ -14,3 +14,29 @@ clip() {
) 2>/dev/null & disown
echo "Copied $2 to clipboard. Will clear in $CLIP_TIME seconds."
}
+
+#replaces Cygwin-style filenames with their Windows counterparts
+gpg_winpath(){
+ args=("$@")
+ #as soon as an argument (from back to front) is no file, it can only be a filename argument if it is preceeded by '-o'
+ could_be_filenames="true"
+
+ for ((i=${#args[@]}-1; i>=0; i--)); do
+ if ( [ $i -gt 0 ] && [ "${args[$i-1]}" = "-o" ] ) || [ $could_be_filenames = "true" ]; then
+ if [ -e ${args[$i]} ]; then
+ args[$i]=$(cygpath -am ${args[$i]})
+ else
+ could_be_filenames="false"
+ fi
+ fi
+
+ done
+
+ $GPG_ORIG "${args[@]}"
+}
+
+if $GPG --help | grep -q Gpg4win; then
+ GPG_ORIG=$GPG
+ GPG=gpg_winpath
+fi
+
--
2.1.1
More information about the Password-Store
mailing list